.\"	$NetBSD: mount_overlay.8,v 1.8 2003/08/07 10:04:30 agc Exp $
.\"
.\" Copyright (c) 1992, 1993, 1994
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" This code is derived from software donated to Berkeley by
.\" John Heidemann of the UCLA Ficus project.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)mount_null.8	8.6 (Berkeley) 5/1/95
.\"
.\"
.Dd January 18, 2000
.Dt MOUNT_OVERLAY 8
.Os
.Sh NAME
.Nm mount_overlay
.Nd mount an overlay filesystem;
demonstrate the use of an overlay file system layer
.Sh SYNOPSIS
.Nm
.Op Fl o Ar options
.Ar /overlay
.Ar mount-point
.Sh DESCRIPTION
The
.Nm
command creates an
overlay layer, interposing the overlay filesystem between the over-mounted
file store and future pathname lookups.
.Pp
A different device number for the virtual copy is returned by
.Xr stat 2 ,
but in other respects it is indistinguishable from the original.
.Pp
The
.Nm
filesystem differs from the null filesystem in that the
.Nm
filesystem does not replicate the sub-tree, it places itself between
the sub-tree and all future access.
.Pp
The overlay layer has two purposes.
First, it serves as a demonstration of layering by providing a layer
which does nothing other than insert itself over the over-mounted
file system.
Second, the overlay layer can serve as a prototype layer.
Since it provides all necessary layer framework,
new file system layers which need to block access to the overlayed
file system can be created very easily by starting
with an overlay layer.
.Pp
The internal operation of the overlay layer is identical to that of the
null layer.
See its documentation for details.
.Sh SEE ALSO
.Xr mount 8 ,
.Xr mount_null 8
.Pp
UCLA Technical Report CSD-910056,
.Em "Stackable Layers: an Architecture for File System Development" .
.Sh HISTORY
The
.Nm
utility first appeared in
.Nx 1.5 .
